// Code generated by mockery 2.9.4. DO NOT EDIT.

package mocks

import (
	event "maunium.net/go/mautrix/event"
	id "maunium.net/go/mautrix/id"

	mautrix "maunium.net/go/mautrix"

	mock "github.com/stretchr/testify/mock"
)

// MatrixClient is an autogenerated mock type for the MatrixClient type
type MatrixClient struct {
	mock.Mock
}

// GetAccountData provides a mock function with given fields: _a0, _a1
func (_m *MatrixClient) GetAccountData(_a0 string, _a1 interface{}) error {
	ret := _m.Called(_a0, _a1)

	var r0 error
	if rf, ok := ret.Get(0).(func(string, interface{}) error); ok {
		r0 = rf(_a0, _a1)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetOwnDisplayName provides a mock function with given fields:
func (_m *MatrixClient) GetOwnDisplayName() (*mautrix.RespUserDisplayName, error) {
	ret := _m.Called()

	var r0 *mautrix.RespUserDisplayName
	if rf, ok := ret.Get(0).(func() *mautrix.RespUserDisplayName); ok {
		r0 = rf()
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*mautrix.RespUserDisplayName)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func() error); ok {
		r1 = rf()
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// JoinRoomByID provides a mock function with given fields: _a0
func (_m *MatrixClient) JoinRoomByID(_a0 id.RoomID) (*mautrix.RespJoinRoom, error) {
	ret := _m.Called(_a0)

	var r0 *mautrix.RespJoinRoom
	if rf, ok := ret.Get(0).(func(id.RoomID) *mautrix.RespJoinRoom); ok {
		r0 = rf(_a0)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*mautrix.RespJoinRoom)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(id.RoomID) error); ok {
		r1 = rf(_a0)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// Logout provides a mock function with given fields:
func (_m *MatrixClient) Logout() (*mautrix.RespLogout, error) {
	ret := _m.Called()

	var r0 *mautrix.RespLogout
	if rf, ok := ret.Get(0).(func() *mautrix.RespLogout); ok {
		r0 = rf()
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*mautrix.RespLogout)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func() error); ok {
		r1 = rf()
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// SendMessageEvent provides a mock function with given fields: _a0, _a1, _a2, _a3
func (_m *MatrixClient) SendMessageEvent(_a0 id.RoomID, _a1 event.Type, _a2 interface{}, _a3 ...mautrix.ReqSendEvent) (*mautrix.RespSendEvent, error) {
	_va := make([]interface{}, len(_a3))
	for _i := range _a3 {
		_va[_i] = _a3[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, _a0, _a1, _a2)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	var r0 *mautrix.RespSendEvent
	if rf, ok := ret.Get(0).(func(id.RoomID, event.Type, interface{}, ...mautrix.ReqSendEvent) *mautrix.RespSendEvent); ok {
		r0 = rf(_a0, _a1, _a2, _a3...)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*mautrix.RespSendEvent)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(id.RoomID, event.Type, interface{}, ...mautrix.ReqSendEvent) error); ok {
		r1 = rf(_a0, _a1, _a2, _a3...)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// SetAccountData provides a mock function with given fields: _a0, _a1
func (_m *MatrixClient) SetAccountData(_a0 string, _a1 interface{}) error {
	ret := _m.Called(_a0, _a1)

	var r0 error
	if rf, ok := ret.Get(0).(func(string, interface{}) error); ok {
		r0 = rf(_a0, _a1)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// SetDisplayName provides a mock function with given fields: _a0
func (_m *MatrixClient) SetDisplayName(_a0 string) error {
	ret := _m.Called(_a0)

	var r0 error
	if rf, ok := ret.Get(0).(func(string) error); ok {
		r0 = rf(_a0)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// SetPresence provides a mock function with given fields: _a0
func (_m *MatrixClient) SetPresence(_a0 event.Presence) error {
	ret := _m.Called(_a0)

	var r0 error
	if rf, ok := ret.Get(0).(func(event.Presence) error); ok {
		r0 = rf(_a0)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// Sync provides a mock function with given fields:
func (_m *MatrixClient) Sync() error {
	ret := _m.Called()

	var r0 error
	if rf, ok := ret.Get(0).(func() error); ok {
		r0 = rf()
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// UserTyping provides a mock function with given fields: _a0, _a1, _a2
func (_m *MatrixClient) UserTyping(_a0 id.RoomID, _a1 bool, _a2 int64) (*mautrix.RespTyping, error) {
	ret := _m.Called(_a0, _a1, _a2)

	var r0 *mautrix.RespTyping
	if rf, ok := ret.Get(0).(func(id.RoomID, bool, int64) *mautrix.RespTyping); ok {
		r0 = rf(_a0, _a1, _a2)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*mautrix.RespTyping)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(id.RoomID, bool, int64) error); ok {
		r1 = rf(_a0, _a1, _a2)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// Whoami provides a mock function with given fields:
func (_m *MatrixClient) Whoami() (*mautrix.RespWhoami, error) {
	ret := _m.Called()

	var r0 *mautrix.RespWhoami
	if rf, ok := ret.Get(0).(func() *mautrix.RespWhoami); ok {
		r0 = rf()
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*mautrix.RespWhoami)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func() error); ok {
		r1 = rf()
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}
